"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by ztt on 2018/9/21.
 */
var ArrayUtils = /** @class */ (function () {
    function ArrayUtils() {
    }
    /**
     * 移除一个元素
     * @param array
     * @param value
     * @param key
     * @returns {any}
     */
    ArrayUtils.remove = function (array, value, key) {
        if (!!array && array instanceof Array) {
            for (var i = 0, j = array.length; i < j; i++) {
                var obj = array[i];
                if (key) {
                    if (obj[key] == value[key]) {
                        array.splice(i, 1);
                        return array;
                    }
                }
                else {
                    if (obj == value) {
                        array.splice(i, 1);
                        return array;
                    }
                }
            }
        }
    };
    /**
     是否是个有效的数组对象，有则返回第一个子元素，否则返回false
     @param array
     @returns {boolean|boolean}
     */
    ArrayUtils.valid = function (array) {
        if (!!array && Array.isArray(array) && array.length > 0) {
            return array[0];
        }
        else {
            return false;
        }
    };
    /**
     * 增加一个元素
     * @param array
     * @param obj
     * @param idKey
     * @param pIdKey
     * @param childKey
     * @returns {any}
     */
    ArrayUtils.addByParentId = function (array, obj, idKey, pIdKey, childKey) {
        if (!!array && !!obj && !!idKey && !!childKey) {
            var pId = obj[pIdKey];
            for (var i = 0, j = array.length; i < j; i++) {
                var item = array[i];
                if (item[idKey] == pId) {
                    if (item[childKey]) {
                        item[childKey].push(obj);
                        return true;
                    }
                    return null;
                }
                else if (!!item[childKey]) {
                    this.addByParentId(item[childKey], obj, idKey, pIdKey, childKey);
                }
            }
        }
        return false;
    };
    return ArrayUtils;
}());
exports.ArrayUtils = ArrayUtils;
